---
title: Selection API
slug: Web/API/Selection_API
tags:
  - API
  - Junk
  - Landing
  - Reference
  - Selection
  - Selection API
  - Text
---
<p>{{DefaultAPISidebar("Selection API")}}</p>

<div class="summary">
<p>The Selection API provides functionality for reading and manipulating the range of text selected by the user.</p>
</div>

<h2 id="Concepts_and_usage">Concepts and usage</h2>

<p>To retrieve the current text range the user has selected, you can use the {{domxref("Window.getSelection()")}} or {{domxref("Document.getSelection()")}} method, storing the return value — a {{domxref("Selection")}} object — in a variable for futher use.</p>

<p>Once your selection is in a variable, you perform a variety of operations on it, for example copying the selection to a text string using {{domxref("Selection.toString()")}}, adding a range (as represented by a standard {{domxref("Range")}} object) to the selection (or removing one) with {{domxref("Selection.addRange()")}}/{{domxref("Selection.removeRange()")}}, or changing the selection to be the entire contents of a DOM node using {{domxref("Selection.selectAllChildren()")}}.</p>

<p>You can run code in response to the selection being changed, or a new selection being started, using the {{domxref("GlobalEventHandlers.onselectionchange")}} and {{domxref("GlobalEventHandlers.onselectstart")}} event handlers.</p>

<h2 id="Selection_API_interfaces">Selection API interfaces</h2>

<dl>
 <dt>{{domxref("Selection")}}</dt>
 <dd>Represents the range of text selected by the user or the current position of the caret.</dd>
</dl>

<h2 id="Extensions_to_other_interfaces">Extensions to other interfaces</h2>

<dl>
 <dt>{{domxref("Window.getSelection()")}}, {{domxref("Document.getSelection()")}}</dt>
 <dd>Returns a {{domxref("Selection")}} object representing the range of text selected by the user or the current position of the caret. <code>Document.getSelection()</code> is basically an alias of <code>Window.getSelection()</code>.</dd>
 <dt>{{domxref("GlobalEventHandlers.onselectstart")}}</dt>
 <dd>Represents the event handler that is called when a {{event("selectstart")}} event is fired on the current object (i.e. when a new range of text is about to be selected by the user).</dd>
 <dt>{{domxref("GlobalEventHandlers.onselectionchange")}}</dt>
 <dd>Represents the event handler that is called when a {{event("selectionchange")}} event is fired on the current object (i.e. when the selected text range changes).</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Selection API', '#definition', 'Selection')}}</td>
   <td>{{Spec2('Selection API')}}</td>
   <td>The Selection API specification is based on the HTML Editing APIs specification and focuses on the Selection-related functionality.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML Editing', '#selection', 'Selection')}}</td>
   <td>{{Spec2('HTML Editing')}}</td>
   <td>Initial (older) definition, which is now outdated.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="Selection"><code>Selection</code></h3>

<div>

<p>{{Compat("api.Selection")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://github.com/chrisdavidmills/selection-api-examples/tree/gh-pages#key-quote-generator">Key quote generator</a>: A simple demo showing typical usage of the Selection API to capture the current selection at any point and copy selections into a list (<a href="https://chrisdavidmills.github.io/selection-api-examples/">see it live also</a>).</li>
 <li>The {{domxref("Range")}} object.</li>
</ul>
